<script>
import VideoCard from '@/components/events/carousel/carousel-card.vue';
import VideoModal from '@/components/events/carousel/video-modal.vue';
import LeftControl from '@/components/events/carousel/left-carousel-control.vue';
import RightControl from '@/components/events/carousel/right-carousel-control.vue';
import { UseLiteVimeo, UseLocalizedVideoSubtitles } from '~/mixins';

export default {
  name: 'VideoCarousel',
  components: {
    VideoCard,
    VideoModal,
    LeftControl,
    RightControl,
  },
  mixins: [UseLiteVimeo, UseLocalizedVideoSubtitles],
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
  data() {
    return {
      cards: [...this.data.videos.map((_, index) => index)],
      innerStyles: {},
      step: '',
      transitioning: false,
      prevActive: false,
      nextActive: false,
      isModalVisible: false,
      selectedVideo: {},
    };
  },
  mounted() {
    this.setStep();
    this.resetTranslate();
  },
  methods: {
    setStep() {
      const innerWidth = this.$refs.inner.scrollWidth;
      const totalCards = this.cards.length;
      this.step = `${innerWidth / totalCards}px`;
    },
    next() {
      if (this.transitioning) return;
      this.transitioning = true;
      this.nextActive = true;
      this.moveLeft();
      this.afterTransition(() => {
        const card = this.cards.shift();
        this.cards.push(card);
        this.resetTranslate();
        this.transitioning = false;
        this.nextActive = false;
      });
    },
    prev() {
      if (this.transitioning) return;
      this.transitioning = true;
      this.prevActive = true;

      this.moveRight();
      this.afterTransition(() => {
        const card = this.cards.pop();
        this.cards.unshift(card);
        this.resetTranslate();
        this.transitioning = false;
        this.prevActive = false;
      });
    },
    moveLeft() {
      this.innerStyles = {
        transform: `translateX(-${this.step})`,
      };
    },
    moveRight() {
      this.innerStyles = {
        transform: `translateX(${this.step})`,
      };
    },
    afterTransition(callback) {
      const listener = () => {
        callback();
        this.$refs.inner.removeEventListener('transitionend', listener);
      };
      this.$refs.inner.addEventListener('transitionend', listener);
    },
    resetTranslate() {
      this.innerStyles = {
        transition: 'none',
        transform: 'translateX(0)',
      };
    },
    showModal() {
      this.isModalVisible = true;
    },
    closeModal() {
      document.documentElement.style.overflow = 'auto';
      this.isModalVisible = false;
      this.selectedVideo = {};
    },
    onVideoClick(video) {
      document.documentElement.style.overflow = 'hidden';
      this.showModal();
      this.selectedVideo = video;
    },
  },
};
</script>

<template>
  <div class="container">
    <div class="carousel">
      <template v-if="cards.length > 3">
        <button class="btn btn__prev" aria-label="Prev" @click="prev">
          <LeftControl :is-active="prevActive" />
        </button>
        <button class="btn btn__next" aria-label="Next" @click="next">
          <RightControl :is-active="nextActive" />
        </button>
      </template>

      <div ref="inner" class="inner" :style="innerStyles">
        <div v-for="card in cards" :key="card" class="card-box">
          <VideoCard
            :video="data.videos[card]"
            @click="() => onVideoClick(data.videos[card])"
          />
        </div>
      </div>
    </div>
    <VideoModal
      v-if="isModalVisible && selectedVideo != {}"
      :light-background="data.light_background || false"
      @close="closeModal"
    >
      <template #body>
        <lite-vimeo
          v-if="selectedVideo.title"
          :videoid="
            getVimeoVideoId(createVideoSource(selectedVideo.video_link))
          "
          :alt="selectedVideo.carousel_identifier"
          autoplay
        ></lite-vimeo>
      </template>
    </VideoModal>
  </div>
</template>

<style lang="scss" scoped>
.container {
  width: 100%;
}

.carousel {
  width: 100%;
  height: 100%;
  padding: $spacing-48 $spacing-16;
  overflow: hidden;
  position: relative;
}

.inner {
  transition: transform 0.2s;
  white-space: nowrap;
}

.card-box {
  display: inline-flex;
  // transition: all .3s ease-in-out;
  // max-width: 350px;
  // min-height: 500px;
}

.btn {
  border: none;
  z-index: 89;
  outline: none;
  position: absolute;
  top: 43%;
  cursor: pointer;

  &__prev {
    left: 4px;
  }

  &__next {
    right: -4px;
  }
}
</style>
